--- old/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_api.c	Mon Aug  5 17:28:23 2019
+++ new/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_api.c	Mon Aug  5 17:28:23 2019
@@ -7541,16 +7942,10 @@
 
 	/* If polling, wait for finish. */
 	if (poll_wait) {
-		if (ql_poll_cmd(ha, sp, poll_wait) != QL_SUCCESS) {
-			int	res;
-
-			res = ql_abort((opaque_t)ha, pkt, 0);
-			if (res != FC_SUCCESS && res != FC_ABORTED) {
-				DEVICE_QUEUE_LOCK(tq);
-				ql_remove_link(&lq->cmd, &sp->cmd);
-				sp->flags &= ~SRB_IN_DEVICE_QUEUE;
-				DEVICE_QUEUE_UNLOCK(tq);
-			}
+		if (ql_poll_cmd(ha, sp, poll_wait) != QL_SUCCESS &&
+		    pkt->pkt_state == FC_PKT_SUCCESS) {
+			pkt->pkt_state = FC_PKT_TIMEOUT;
+			pkt->pkt_reason = FC_REASON_HW_ERROR;
 		}
 
 		if (pkt->pkt_state != FC_PKT_SUCCESS) {
@@ -7573,6 +7968,7 @@
 			}
 		}
 
+		(void) qlc_fm_check_pkt_dma_handle(ha, sp);
 		/*
 		 * This should only happen during CPR dumping
 		 */
@@ -7583,7 +7979,7 @@
 		}
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (rval);
 }
@@ -7606,16 +8002,18 @@
 static int
 ql_poll_cmd(ql_adapter_state_t *vha, ql_srb_t *sp, time_t poll_wait)
 {
+	uint32_t		index;
 	int			rval = QL_SUCCESS;
 	time_t			msecs_left = poll_wait * 100;	/* 10ms inc */
 	ql_adapter_state_t	*ha = vha->pha;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	while (sp->flags & SRB_POLL) {
 
 		if ((ha->flags & INTERRUPTS_ENABLED) == 0 ||
-		    ha->idle_timer >= 15 || ddi_in_panic()) {
+		    ha->idle_timer >= 15 || ddi_in_panic() ||
+		    curthread->t_flag & T_INTR_THREAD) {
 
 			/* If waiting for restart, do it now. */
 			if (ha->port_retry_timer != 0) {
@@ -7628,13 +8026,28 @@
 				TASK_DAEMON_UNLOCK(ha);
 			}
 
+			ADAPTER_STATE_LOCK(ha);
+			ha->flags |= POLL_INTR;
+			ADAPTER_STATE_UNLOCK(ha);
+
 			if (INTERRUPT_PENDING(ha)) {
-				(void) ql_isr((caddr_t)ha);
+				(void) ql_isr_aif((caddr_t)ha, 0);
 				INTR_LOCK(ha);
 				ha->intr_claimed = TRUE;
 				INTR_UNLOCK(ha);
 			}
+			if (ha->flags & NO_INTR_HANDSHAKE) {
+				for (index = 0; index < ha->rsp_queues_cnt;
+				    index++) {
+					(void) ql_isr_aif((caddr_t)ha,
+					    (caddr_t)((uintptr_t)(index + 1)));
+				}
+			}
 
+			ADAPTER_STATE_LOCK(ha);
+			ha->flags &= ~POLL_INTR;
+			ADAPTER_STATE_UNLOCK(ha);
+
 			/*
 			 * Call task thread function in case the
 			 * daemon is not running.
@@ -7643,17 +8056,30 @@
 
 			if (!ddi_in_panic() && QL_DAEMON_NOT_ACTIVE(ha) &&
 			    QL_TASK_PENDING(ha)) {
-				ha->task_daemon_flags |= TASK_THREAD_CALLED;
 				ql_task_thread(ha);
-				ha->task_daemon_flags &= ~TASK_THREAD_CALLED;
 			}
 
 			TASK_DAEMON_UNLOCK(ha);
 		}
 
-		if (msecs_left < 10) {
-			rval = QL_FUNCTION_TIMEOUT;
-			break;
+		if (msecs_left == 0) {
+			if (rval == QL_SUCCESS) {
+				EL(ha, "timeout\n");
+				rval = QL_FUNCTION_TIMEOUT;
+				if (ql_abort_io(ha, sp) == QL_SUCCESS) {
+					sp->pkt->pkt_reason = CS_ABORTED;
+					sp->cmd.next = NULL;
+					ql_done(&sp->cmd, B_FALSE);
+					break;
+				}
+				sp->flags |= SRB_COMMAND_TIMEOUT;
+				EL(ha, "abort failed, isp_abort_needed\n");
+				ql_awaken_task_daemon(ha, NULL,
+				    ISP_ABORT_NEEDED, 0);
+				msecs_left = 30 * 100;
+			} else {
+				break;
+			}
 		}
 
 		/*
@@ -7669,7 +8095,7 @@
 		msecs_left -= 10;
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (rval);
 }
@@ -7697,12 +8123,11 @@
 	ql_tgt_t		*tq = lq->target_queue;
 	ql_adapter_state_t	*ha = vha->pha;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	if (ddi_in_panic()) {
 		DEVICE_QUEUE_UNLOCK(tq);
-		QL_PRINT_3(CE_CONT, "(%d): panic/active exit\n",
-		    ha->instance);
+		QL_PRINT_3(ha, "panic/active exit\n");
 		return;
 	}
 
@@ -7713,13 +8138,12 @@
 		if (DRIVER_SUSPENDED(ha) ||
 		    (ha->flags & ONLINE) == 0 ||
 		    !VALID_DEVICE_ID(ha, tq->loop_id) ||
-		    sp->flags & SRB_ABORT ||
 		    tq->flags & (TQF_RSCN_RCVD | TQF_NEED_AUTHENTICATION |
 		    TQF_QUEUE_SUSPENDED)) {
 			EL(vha, "break, d_id=%xh, tdf=%xh, tqf=%xh, spf=%xh, "
-			    "haf=%xh, loop_id=%xh\n", tq->d_id.b24,
+			    "haf=%xh, loop_id=%xh sp=%ph\n", tq->d_id.b24,
 			    ha->task_daemon_flags, tq->flags, sp->flags,
-			    ha->flags, tq->loop_id);
+			    ha->flags, tq->loop_id, sp);
 			break;
 		}
 
@@ -7732,8 +8156,8 @@
 		if (sp->flags & SRB_FCP_CMD_PKT) {
 			if (lq->flags & LQF_UNTAGGED_PENDING ||
 			    lq->lun_outcnt >= ha->execution_throttle) {
-				QL_PRINT_8(CE_CONT, "(%d): break, d_id=%xh, "
-				    "lf=%xh, lun_outcnt=%xh\n", ha->instance,
+				QL_PRINT_8(ha, "break, d_id=%xh, "
+				    "lf=%xh, lun_outcnt=%xh\n",
 				    tq->d_id.b24, lq->flags, lq->lun_outcnt);
 				break;
 			}
@@ -7763,7 +8187,7 @@
 	/* Release device queue lock. */
 	DEVICE_QUEUE_UNLOCK(tq);
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -7772,12 +8196,13 @@
  *
  * Input:
  *	link:	first command link in chain.
+ *	cmplt:	do command complete call back.
  *
  * Context:
  *	Interrupt or Kernel context, no mailbox commands allowed.
  */
 void
-ql_done(ql_link_t *link)
+ql_done(ql_link_t *link, boolean_t cmplt)
 {
 	ql_adapter_state_t	*ha;
 	ql_link_t		*next_link;
@@ -7784,13 +8209,17 @@
 	ql_srb_t		*sp;
 	ql_tgt_t		*tq;
 	ql_lun_t		*lq;
+	uint64_t		set_flags;
 
-	QL_PRINT_3(CE_CONT, "started\n");
+	QL_PRINT_3(NULL, "started\n");
 
 	for (; link != NULL; link = next_link) {
 		next_link = link->next;
 		sp = link->base_address;
+		link->prev = link->next = NULL;
+		link->head = NULL;
 		ha = sp->ha;
+		set_flags = 0;
 
 		if (sp->flags & SRB_UB_CALLBACK) {
 			QL_UB_LOCK(ha);
@@ -7798,20 +8227,24 @@
 				if (ha->ub_outcnt != 0) {
 					ha->ub_outcnt--;
 				}
-				QL_UB_UNLOCK(ha);
-				ql_isp_rcvbuf(ha);
-				QL_UB_LOCK(ha);
+				if (ha->flags & IP_ENABLED) {
+					set_flags |= NEED_UNSOLICITED_BUFFERS;
+				}
 			}
 			QL_UB_UNLOCK(ha);
-			ql_awaken_task_daemon(ha, sp, 0, 0);
+			ql_awaken_task_daemon(ha, sp, set_flags, 0);
 		} else {
 			/* Free outstanding command slot. */
+			INTR_LOCK(ha);
 			if (sp->handle != 0) {
-				ha->outstanding_cmds[
+				EL(ha, "free sp=%ph, sp->hdl=%xh\n",
+				    (void *)sp, sp->handle);
+				ha->pha->outstanding_cmds[
 				    sp->handle & OSC_INDEX_MASK] = NULL;
 				sp->handle = 0;
 				sp->flags &= ~SRB_IN_TOKEN_ARRAY;
 			}
+			INTR_UNLOCK(ha);
 
 			/* Acquire device queue lock. */
 			lq = sp->lun_queue;
@@ -7874,7 +8307,7 @@
 				/* Issue marker command on reset status. */
 				if (!(ha->task_daemon_flags & LOOP_DOWN) &&
 				    (sp->pkt->pkt_reason == CS_RESET ||
-				    (CFG_IST(ha, CFG_CTRL_24258081) &&
+				    (CFG_IST(ha, CFG_ISP_FW_TYPE_2) &&
 				    sp->pkt->pkt_reason == CS_ABORTED))) {
 					(void) ql_marker(ha, tq->loop_id, 0,
 					    MK_SYNC_ID);
@@ -7916,13 +8349,6 @@
 					sp->pkt->pkt_state = FC_PKT_SUCCESS;
 					break;
 				case CS_RESET:
-					/* Issue marker command. */
-					if (!(ha->task_daemon_flags &
-					    LOOP_DOWN)) {
-						(void) ql_marker(ha,
-						    tq->loop_id, 0,
-						    MK_SYNC_ID);
-					}
 					sp->pkt->pkt_state =
 					    FC_PKT_PORT_OFFLINE;
 					sp->pkt->pkt_reason =
@@ -7981,6 +8407,7 @@
 					break;
 
 				case CS_TRANSPORT:
+				case CS_DEV_NOT_READY:
 					sp->pkt->pkt_state = FC_PKT_LOCAL_RJT;
 					sp->pkt->pkt_reason =
 					    FC_PKT_TRAN_ERROR;
@@ -8002,23 +8429,22 @@
 					break;
 				}
 
+				(void) qlc_fm_check_pkt_dma_handle(ha, sp);
+
 				/* Now call the pkt completion callback */
 				if (sp->flags & SRB_POLL) {
 					sp->flags &= ~SRB_POLL;
-				} else if (sp->pkt->pkt_comp) {
-					if (sp->pkt->pkt_tran_flags &
-					    FC_TRAN_IMMEDIATE_CB) {
-						(*sp->pkt->pkt_comp)(sp->pkt);
-					} else {
-						ql_awaken_task_daemon(ha, sp,
-						    0, 0);
-					}
+				} else if (cmplt == B_TRUE &&
+				    sp->pkt->pkt_comp) {
+					(sp->pkt->pkt_comp)(sp->pkt);
+				} else {
+					ql_io_comp(sp);
 				}
 			}
 		}
 	}
 
-	QL_PRINT_3(CE_CONT, "done\n");
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -8037,56 +8463,46 @@
  */
 void
 ql_awaken_task_daemon(ql_adapter_state_t *vha, ql_srb_t *sp,
-    uint32_t set_flags, uint32_t reset_flags)
+    uint64_t set_flags, uint64_t reset_flags)
 {
 	ql_adapter_state_t	*ha = vha->pha;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started, sp=%p set_flags=%llx reset_flags=%llx\n",
+	    sp, set_flags, reset_flags);
 
 	/* Acquire task daemon lock. */
 	TASK_DAEMON_LOCK(ha);
 
-	if (set_flags & ISP_ABORT_NEEDED) {
-		if (ha->task_daemon_flags & ABORT_ISP_ACTIVE) {
-			set_flags &= ~ISP_ABORT_NEEDED;
-		}
+	if (set_flags) {
+		ha->task_daemon_flags |= set_flags;
 	}
+	if (reset_flags) {
+		ha->task_daemon_flags &= ~reset_flags;
+	}
 
-	ha->task_daemon_flags |= set_flags;
-	ha->task_daemon_flags &= ~reset_flags;
+	if (!(ha->task_daemon_flags & TASK_DAEMON_ALIVE_FLG)) {
+		EL(ha, "done, not alive dtf=%xh\n", ha->task_daemon_flags);
+		TASK_DAEMON_UNLOCK(ha);
+		return;
+	}
 
-	if (QL_DAEMON_SUSPENDED(ha)) {
-		if (sp != NULL) {
-			TASK_DAEMON_UNLOCK(ha);
-
-			/* Do callback. */
-			if (sp->flags & SRB_UB_CALLBACK) {
-				ql_unsol_callback(sp);
-			} else {
-				(*sp->pkt->pkt_comp)(sp->pkt);
-			}
+	if (sp != NULL) {
+		if (sp->flags & SRB_UB_CALLBACK) {
+			ql_add_link_b(&ha->unsol_callback_queue, &sp->cmd);
 		} else {
-			if (!(curthread->t_flag & T_INTR_THREAD) &&
-			    !(ha->task_daemon_flags & TASK_THREAD_CALLED)) {
-				ha->task_daemon_flags |= TASK_THREAD_CALLED;
-				ql_task_thread(ha);
-				ha->task_daemon_flags &= ~TASK_THREAD_CALLED;
-			}
-
-			TASK_DAEMON_UNLOCK(ha);
+			EL(ha, "sp=%p, spf=%xh is not SRB_UB_CALLBACK",
+			    sp->flags);
 		}
-	} else {
-		if (sp != NULL) {
-			ql_add_link_b(&ha->callback_queue, &sp->cmd);
-		}
+	}
 
-		if (ha->task_daemon_flags & TASK_DAEMON_SLEEPING_FLG) {
-			cv_broadcast(&ha->cv_task_daemon);
-		}
-		TASK_DAEMON_UNLOCK(ha);
+	if (!ha->driver_thread_awake) {
+		QL_PRINT_3(ha, "driver_thread_awake\n");
+		cv_broadcast(&ha->cv_task_daemon);
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	TASK_DAEMON_UNLOCK(ha);
+
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -8105,21 +8521,14 @@
 {
 	ql_adapter_state_t	*ha = (void *)arg;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
-	CALLB_CPR_INIT(&ha->cprinfo, &ha->task_daemon_mutex, callb_generic_cpr,
-	    "ql_task_daemon");
-
 	/* Acquire task daemon lock. */
 	TASK_DAEMON_LOCK(ha);
 
-	ha->task_daemon_flags |= TASK_DAEMON_ALIVE_FLG;
-
 	while ((ha->task_daemon_flags & TASK_DAEMON_STOP_FLG) == 0) {
 		ql_task_thread(ha);
 
-		QL_PRINT_3(CE_CONT, "(%d): Going to sleep\n", ha->instance);
-
 		/*
 		 * Before we wait on the conditional variable, we
 		 * need to check if STOP_FLG is set for us to terminate
@@ -8128,34 +8537,26 @@
 			break;
 		}
 
-		/*LINTED [Solaris CALLB_CPR_SAFE_BEGIN Lint error]*/
-		CALLB_CPR_SAFE_BEGIN(&ha->cprinfo);
-
+		QL_PRINT_3(ha, "Going to sleep\n");
 		ha->task_daemon_flags |= TASK_DAEMON_SLEEPING_FLG;
 
 		/* If killed, stop task daemon */
 		if (cv_wait_sig(&ha->cv_task_daemon,
 		    &ha->task_daemon_mutex) == 0) {
-			ha->task_daemon_flags |= TASK_DAEMON_STOP_FLG;
+			QL_PRINT_10(ha, "killed\n");
+			break;
 		}
 
+		QL_PRINT_3(ha, "Awakened\n");
 		ha->task_daemon_flags &= ~TASK_DAEMON_SLEEPING_FLG;
-
-		/*LINTED [Solaris CALLB_CPR_SAFE_END Lint error]*/
-		CALLB_CPR_SAFE_END(&ha->cprinfo, &ha->task_daemon_mutex);
-
-		QL_PRINT_3(CE_CONT, "(%d): Awakened\n", ha->instance);
 	}
 
-	ha->task_daemon_flags &= ~(TASK_DAEMON_STOP_FLG |
+	ha->task_daemon_flags &= ~(TASK_DAEMON_SLEEPING_FLG |
 	    TASK_DAEMON_ALIVE_FLG);
 
-	/*LINTED [Solaris CALLB_CPR_EXIT Lint error]*/
-	CALLB_CPR_EXIT(&ha->cprinfo);
+	TASK_DAEMON_UNLOCK(ha);
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
-
-	thread_exit();
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -8172,66 +8573,76 @@
 static void
 ql_task_thread(ql_adapter_state_t *ha)
 {
-	int			loop_again;
+	boolean_t		loop_again;
 	ql_srb_t		*sp;
-	ql_head_t		*head;
 	ql_link_t		*link;
 	caddr_t			msg;
 	ql_adapter_state_t	*vha;
 
+	ha->driver_thread_awake++;
 	do {
-		QL_PRINT_3(CE_CONT, "(%d): task_daemon_flags=%xh\n",
-		    ha->instance, ha->task_daemon_flags);
+		loop_again = B_FALSE;
 
-		loop_again = FALSE;
+		if (ha->sf != ha->flags ||
+		    (ha->task_daemon_flags & ~DTF_EL_MSG_SKIP_FLGS) != ha->df ||
+		    ha->cf != ha->cfg_flags) {
+			ha->sf = ha->flags;
+			ha->df = ha->task_daemon_flags & ~DTF_EL_MSG_SKIP_FLGS;
+			ha->cf = ha->cfg_flags;
+			EL(ha, "df=%xh, sf=%xh, cf=%xh\n",
+			    ha->df, ha->sf, ha->cf);
+		}
 
 		QL_PM_LOCK(ha);
 		if (ha->power_level != PM_LEVEL_D0) {
 			QL_PM_UNLOCK(ha);
-			ha->task_daemon_flags |= TASK_DAEMON_STALLED_FLG;
+			ha->task_daemon_flags |= DRIVER_STALL |
+			    TASK_DAEMON_STALLED_FLG;
 			break;
 		}
 		QL_PM_UNLOCK(ha);
 
-		/* IDC event. */
-		if (ha->task_daemon_flags & IDC_EVENT) {
-			ha->task_daemon_flags &= ~IDC_EVENT;
+		if (ha->flags & ADAPTER_SUSPENDED) {
+			ha->task_daemon_flags |= TASK_DAEMON_STALLED_FLG;
+			break;
+		}
+
+		/* Handle FW IDC events. */
+		while (ha->flags & (IDC_STALL_NEEDED | IDC_RESTART_NEEDED |
+		    IDC_ACK_NEEDED)) {
 			TASK_DAEMON_UNLOCK(ha);
-			ql_process_idc_event(ha);
+			ql_idc(ha);
 			TASK_DAEMON_LOCK(ha);
-			loop_again = TRUE;
+			loop_again = B_TRUE;
 		}
 
-		if (ha->flags & ADAPTER_SUSPENDED || ha->task_daemon_flags &
+		if (ha->task_daemon_flags &
 		    (TASK_DAEMON_STOP_FLG | DRIVER_STALL) ||
-		    (ha->flags & ONLINE) == 0) {
+		    !(ha->flags & ONLINE)) {
 			ha->task_daemon_flags |= TASK_DAEMON_STALLED_FLG;
 			break;
 		}
 		ha->task_daemon_flags &= ~TASK_DAEMON_STALLED_FLG;
 
-		if (ha->task_daemon_flags & ISP_ABORT_NEEDED) {
+		/* Store error log. */
+		if (ha->errlog[0] != 0 &&
+		    !(ha->task_daemon_flags & ISP_ABORT_NEEDED)) {
 			TASK_DAEMON_UNLOCK(ha);
-			if (ha->log_parity_pause == B_TRUE) {
-				(void) ql_flash_errlog(ha,
-				    FLASH_ERRLOG_PARITY_ERR, 0,
-				    MSW(ha->parity_stat_err),
-				    LSW(ha->parity_stat_err));
-				ha->log_parity_pause = B_FALSE;
-			}
-			ql_port_state(ha, FC_STATE_OFFLINE, FC_STATE_CHANGE);
+			(void) ql_flash_errlog(ha, ha->errlog[0],
+			    ha->errlog[1], ha->errlog[2], ha->errlog[3]);
+			ha->errlog[0] = 0;
 			TASK_DAEMON_LOCK(ha);
-			loop_again = TRUE;
+			loop_again = B_TRUE;
 		}
 
 		/* Idle Check. */
 		if (ha->task_daemon_flags & TASK_DAEMON_IDLE_CHK_FLG) {
 			ha->task_daemon_flags &= ~TASK_DAEMON_IDLE_CHK_FLG;
-			if (!(ha->task_daemon_flags & QL_SUSPENDED)) {
+			if (!DRIVER_SUSPENDED(ha)) {
 				TASK_DAEMON_UNLOCK(ha);
 				ql_idle_check(ha);
 				TASK_DAEMON_LOCK(ha);
-				loop_again = TRUE;
+				loop_again = B_TRUE;
 			}
 		}
 
@@ -8241,23 +8652,26 @@
 			TASK_DAEMON_UNLOCK(ha);
 			(void) ql_initiate_lip(ha);
 			TASK_DAEMON_LOCK(ha);
-			loop_again = TRUE;
+			loop_again = B_TRUE;
 		}
 
 		/* Abort queues needed. */
 		if (ha->task_daemon_flags & ABORT_QUEUES_NEEDED) {
 			ha->task_daemon_flags &= ~ABORT_QUEUES_NEEDED;
-			TASK_DAEMON_UNLOCK(ha);
-			ql_abort_queues(ha);
-			TASK_DAEMON_LOCK(ha);
+			if (ha->flags & ABORT_CMDS_LOOP_DOWN_TMO) {
+				TASK_DAEMON_UNLOCK(ha);
+				ql_abort_queues(ha);
+				TASK_DAEMON_LOCK(ha);
+				loop_again = B_TRUE;
+			}
 		}
 
 		/* Not suspended, awaken waiting routines. */
-		if (!(ha->task_daemon_flags & QL_SUSPENDED) &&
+		if (!DRIVER_SUSPENDED(ha) &&
 		    ha->task_daemon_flags & SUSPENDED_WAKEUP_FLG) {
 			ha->task_daemon_flags &= ~SUSPENDED_WAKEUP_FLG;
 			cv_broadcast(&ha->cv_dr_suspended);
-			loop_again = TRUE;
+			loop_again = B_TRUE;
 		}
 
 		/* Handle RSCN changes. */
@@ -8267,7 +8681,7 @@
 				TASK_DAEMON_UNLOCK(ha);
 				(void) ql_handle_rscn_update(vha);
 				TASK_DAEMON_LOCK(ha);
-				loop_again = TRUE;
+				loop_again = B_TRUE;
 			}
 		}
 
@@ -8293,6 +8707,7 @@
 						TASK_DAEMON_LOCK(ha);
 						ha->task_daemon_flags &=
 						    ~COMMAND_WAIT_ACTIVE;
+						loop_again = B_TRUE;
 					}
 				}
 
@@ -8335,40 +8750,21 @@
 				}
 
 				if (vha->flags & FCA_BOUND) {
-					QL_PRINT_10(CE_CONT, "(%d,%d): statec_"
-					    "cb state=%xh\n", ha->instance,
-					    vha->vp_index, vha->state);
+					QL_PRINT_10(vha, "statec_"
+					    "cb state=%xh\n",
+					    vha->state);
 					TASK_DAEMON_UNLOCK(ha);
 					(vha->bind_info.port_statec_cb)
 					    (vha->bind_info.port_handle,
 					    vha->state);
 					TASK_DAEMON_LOCK(ha);
+					loop_again = B_TRUE;
 				}
-				loop_again = TRUE;
 			}
 		}
 
-		if (ha->task_daemon_flags & LIP_RESET_PENDING &&
-		    !(ha->task_daemon_flags & TASK_DAEMON_POWERING_DOWN)) {
-			EL(ha, "processing LIP reset\n");
-			ha->task_daemon_flags &= ~LIP_RESET_PENDING;
-			TASK_DAEMON_UNLOCK(ha);
-			for (vha = ha; vha != NULL; vha = vha->vp_next) {
-				if (vha->flags & FCA_BOUND) {
-					QL_PRINT_10(CE_CONT, "(%d,%d): statec_"
-					    "cb reset\n", ha->instance,
-					    vha->vp_index);
-					(vha->bind_info.port_statec_cb)
-					    (vha->bind_info.port_handle,
-					    FC_STATE_TARGET_PORT_RESET);
-				}
-			}
-			TASK_DAEMON_LOCK(ha);
-			loop_again = TRUE;
-		}
-
-		if (QL_IS_SET(ha->task_daemon_flags, NEED_UNSOLICITED_BUFFERS |
-		    FIRMWARE_UP)) {
+		if (ha->task_daemon_flags & NEED_UNSOLICITED_BUFFERS &&
+		    ha->task_daemon_flags & FIRMWARE_UP) {
 			/*
 			 * The firmware needs more unsolicited
 			 * buffers. We cannot allocate any new
@@ -8381,44 +8777,57 @@
 			TASK_DAEMON_UNLOCK(ha);
 			ql_isp_rcvbuf(ha);
 			TASK_DAEMON_LOCK(ha);
-			loop_again = TRUE;
+			loop_again = B_TRUE;
 		}
 
+		if (ha->task_daemon_flags & WATCHDOG_NEEDED) {
+			ha->task_daemon_flags &= ~WATCHDOG_NEEDED;
+			TASK_DAEMON_UNLOCK(ha);
+			ql_watchdog(ha);
+			TASK_DAEMON_LOCK(ha);
+			loop_again = B_TRUE;
+		}
+
 		if (ha->task_daemon_flags & ISP_ABORT_NEEDED) {
 			TASK_DAEMON_UNLOCK(ha);
 			(void) ql_abort_isp(ha);
 			TASK_DAEMON_LOCK(ha);
-			loop_again = TRUE;
+			loop_again = B_TRUE;
 		}
 
-		if (!(ha->task_daemon_flags & (LOOP_DOWN | DRIVER_STALL |
-		    COMMAND_WAIT_NEEDED))) {
-			if (QL_IS_SET(ha->task_daemon_flags,
-			    RESET_MARKER_NEEDED | FIRMWARE_UP)) {
-				ha->task_daemon_flags &= ~RESET_MARKER_NEEDED;
-				if (!(ha->task_daemon_flags & RESET_ACTIVE)) {
-					ha->task_daemon_flags |= RESET_ACTIVE;
+		if (!(ha->task_daemon_flags & (COMMAND_WAIT_NEEDED |
+		    ABORT_QUEUES_NEEDED | ISP_ABORT_NEEDED | LOOP_DOWN)) &&
+		    ha->task_daemon_flags & FIRMWARE_UP) {
+			if (ha->task_daemon_flags & MARKER_NEEDED) {
+				if (!(ha->task_daemon_flags & MARKER_ACTIVE)) {
+					ha->task_daemon_flags |= MARKER_ACTIVE;
+					ha->task_daemon_flags &= ~MARKER_NEEDED;
 					TASK_DAEMON_UNLOCK(ha);
 					for (vha = ha; vha != NULL;
 					    vha = vha->vp_next) {
-						ql_rst_aen(vha);
+						(void) ql_marker(vha, 0, 0,
+						    MK_SYNC_ALL);
 					}
 					TASK_DAEMON_LOCK(ha);
-					ha->task_daemon_flags &= ~RESET_ACTIVE;
-					loop_again = TRUE;
+					ha->task_daemon_flags &= ~MARKER_ACTIVE;
+					TASK_DAEMON_UNLOCK(ha);
+					ql_restart_queues(ha);
+					TASK_DAEMON_LOCK(ha);
+					loop_again = B_TRUE;
+				} else {
+					ha->task_daemon_flags &= ~MARKER_NEEDED;
 				}
 			}
 
-			if (QL_IS_SET(ha->task_daemon_flags,
-			    LOOP_RESYNC_NEEDED | FIRMWARE_UP)) {
+			if (ha->task_daemon_flags & LOOP_RESYNC_NEEDED) {
 				if (!(ha->task_daemon_flags &
 				    LOOP_RESYNC_ACTIVE)) {
 					ha->task_daemon_flags |=
 					    LOOP_RESYNC_ACTIVE;
 					TASK_DAEMON_UNLOCK(ha);
-					(void) ql_loop_resync(ha);
+					ql_loop_resync(ha);
 					TASK_DAEMON_LOCK(ha);
-					loop_again = TRUE;
+					loop_again = B_TRUE;
 				}
 			}
 		}
@@ -8439,7 +8848,6 @@
 		/* iiDMA setting needed? */
 		if (ha->task_daemon_flags & TD_IIDMA_NEEDED) {
 			ha->task_daemon_flags &= ~TD_IIDMA_NEEDED;
-
 			TASK_DAEMON_UNLOCK(ha);
 			ql_iidma(ha);
 			TASK_DAEMON_LOCK(ha);
@@ -8451,33 +8859,41 @@
 			TASK_DAEMON_UNLOCK(ha);
 			(void) ql_n_port_plogi(ha);
 			TASK_DAEMON_LOCK(ha);
+			loop_again = B_TRUE;
 		}
 
-		head = &ha->callback_queue;
-		if (head->first != NULL) {
-			sp = head->first->base_address;
+		if (ha->unsol_callback_queue.first != NULL) {
+			sp = (ha->unsol_callback_queue.first)->base_address;
 			link = &sp->cmd;
-
-			/* Dequeue command. */
-			ql_remove_link(head, link);
-
-			/* Release task daemon lock. */
+			ql_remove_link(&ha->unsol_callback_queue, link);
 			TASK_DAEMON_UNLOCK(ha);
+			ql_unsol_callback(sp);
+			TASK_DAEMON_LOCK(ha);
+			loop_again = B_TRUE;
+		}
 
-			/* Do callback. */
-			if (sp->flags & SRB_UB_CALLBACK) {
-				ql_unsol_callback(sp);
-			} else {
-				(*sp->pkt->pkt_comp)(sp->pkt);
-			}
-
-			/* Acquire task daemon lock. */
+		if (ha->task_daemon_flags & IDC_POLL_NEEDED) {
+			ha->task_daemon_flags &= ~IDC_POLL_NEEDED;
+			TASK_DAEMON_UNLOCK(ha);
+			ql_8021_idc_poll(ha);
 			TASK_DAEMON_LOCK(ha);
+			loop_again = B_TRUE;
+		}
 
-			loop_again = TRUE;
+		if (ha->task_daemon_flags & LED_BLINK) {
+			ha->task_daemon_flags &= ~LED_BLINK;
+			TASK_DAEMON_UNLOCK(ha);
+			ql_blink_led(ha);
+			TASK_DAEMON_LOCK(ha);
+			loop_again = B_TRUE;
 		}
 
-	} while (loop_again);
+	} while (loop_again == B_TRUE);
+
+	if (ha->driver_thread_awake) {
+		ha->driver_thread_awake--;
+	}
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -8493,23 +8909,16 @@
 static void
 ql_idle_check(ql_adapter_state_t *ha)
 {
-	ddi_devstate_t	state;
 	int		rval;
 	ql_mbx_data_t	mr;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	/* Firmware Ready Test. */
 	rval = ql_get_firmware_state(ha, &mr);
-	if (!(ha->task_daemon_flags & QL_SUSPENDED) &&
+	if (!DRIVER_SUSPENDED(ha) &&
 	    (rval != QL_SUCCESS || mr.mb[1] != FSTATE_READY)) {
 		EL(ha, "failed, Firmware Ready Test = %xh\n", rval);
-		state = ddi_get_devstate(ha->dip);
-		if (state == DDI_DEVSTATE_UP) {
-			/*EMPTY*/
-			ddi_dev_report_fault(ha->dip, DDI_SERVICE_DEGRADED,
-			    DDI_DEVICE_FAULT, "Firmware Ready Test failed");
-		}
 		TASK_DAEMON_LOCK(ha);
 		if (!(ha->task_daemon_flags & ABORT_ISP_ACTIVE)) {
 			EL(ha, "fstate_ready, isp_abort_needed\n");
@@ -8518,7 +8927,7 @@
 		TASK_DAEMON_UNLOCK(ha);
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -8542,7 +8951,7 @@
 	ql_tgt_t		*tq;
 	ql_adapter_state_t	*ha = sp->ha, *pha = sp->ha->pha;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	ubp = ha->ub_array[sp->handle];
 	r_ctl = ubp->ub_frame.r_ctl;
@@ -8566,7 +8975,7 @@
 
 	/* Process RSCN */
 	if (sp->flags & SRB_UB_RSCN) {
-		int sendup = 1;
+		int sendup;
 
 		/*
 		 * Defer RSCN posting until commands return
@@ -8580,7 +8989,7 @@
 		if (sendup == 0) {
 
 			TASK_DAEMON_LOCK(ha);
-			ql_add_link_b(&pha->callback_queue, &sp->cmd);
+			ql_add_link_b(&pha->unsol_callback_queue, &sp->cmd);
 			TASK_DAEMON_UNLOCK(ha);
 
 			/*
@@ -8589,8 +8998,8 @@
 			 */
 			ql_delay(ha, 10000);
 
-			QL_PRINT_2(CE_CONT, "(%d,%d): done rscn_sendup=0, "
-			    "fmt=%xh, d_id=%xh\n", ha->instance, ha->vp_index,
+			QL_PRINT_2(ha, "done rscn_sendup=0, "
+			    "fmt=%xh, d_id=%xh\n",
 			    af->aff_format, af->aff_d_id);
 			return;
 		}
@@ -8607,10 +9016,10 @@
 
 		if (tq && (ql_process_logo_for_device(ha, tq) == 0)) {
 			TASK_DAEMON_LOCK(ha);
-			ql_add_link_b(&pha->callback_queue, &sp->cmd);
+			ql_add_link_b(&pha->unsol_callback_queue, &sp->cmd);
 			TASK_DAEMON_UNLOCK(ha);
-			QL_PRINT_2(CE_CONT, "(%d,%d): logo_sendup=0, d_id=%xh"
-			    "\n", ha->instance, ha->vp_index, tq->d_id.b24);
+			QL_PRINT_2(ha, "logo_sendup=0, d_id=%xh"
+			    "\n", tq->d_id.b24);
 			return;
 		}
 
@@ -8619,6 +9028,11 @@
 		    ubp->ub_frame.s_id);
 	}
 
+	if ((r_ctl == R_CTL_ELS_REQ) && (ls_code == LA_ELS_PLOGI)) {
+		EL(ha, "sending unsol plogi for %xh to transport\n",
+		    ubp->ub_frame.s_id);
+	}
+
 	sp->flags &= ~(SRB_UB_IN_FCA | SRB_UB_IN_ISP | SRB_UB_RSCN |
 	    SRB_UB_FCP);
 
@@ -8631,7 +9045,7 @@
 	(ha->bind_info.port_unsol_cb)(ha->bind_info.port_handle,
 	    ubp, sp->ub_type);
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -8653,10 +9067,9 @@
 	la_els_logo_t		*payload;
 	ql_adapter_state_t	*ha = vha->pha;
 
-	QL_PRINT_3(CE_CONT, "(%d): started, d_id=%xh\n", ha->instance,
-	    tq->d_id.b24);
+	QL_PRINT_3(ha, "started, d_id=%xh\n", tq->d_id.b24);
 
-	if ((tq->d_id.b24 == 0) || (tq->d_id.b24 == 0xffffff)) {
+	if ((tq->d_id.b24 == 0) || (tq->d_id.b24 == FS_BROADCAST)) {
 		EL(ha, "no device, d_id=%xh\n", tq->d_id.b24);
 		return;
 	}
@@ -8676,8 +9089,6 @@
 		tq->logout_sent++;
 		DEVICE_QUEUE_UNLOCK(tq);
 
-		EL(vha, "Received LOGO from = %xh\n", tq->d_id.b24);
-
 		sp = ubp->ub_fca_private;
 
 		/* Set header. */
@@ -8721,7 +9132,7 @@
 		}
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 static int
@@ -8732,7 +9143,7 @@
 	ql_link_t	*link;
 	int		sendup = 1;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	DEVICE_QUEUE_LOCK(tq);
 	if (tq->outcnt) {
@@ -8744,7 +9155,7 @@
 		DEVICE_QUEUE_UNLOCK(tq);
 		TASK_DAEMON_LOCK(ha);
 
-		for (link = ha->pha->callback_queue.first; link != NULL;
+		for (link = ha->pha->unsol_callback_queue.first; link != NULL;
 		    link = link->next) {
 			sp = link->base_address;
 			if (sp->flags & SRB_UB_CALLBACK) {
@@ -8761,7 +9172,7 @@
 		TASK_DAEMON_UNLOCK(ha);
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (sendup);
 }
@@ -8774,7 +9185,7 @@
 	la_els_logi_t		*payload;
 	class_svc_param_t	*class3_param;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	if ((tq->flags & TQF_RSCN_RCVD) || (ha->task_daemon_flags &
 	    LOOP_DOWN)) {
@@ -8789,8 +9200,7 @@
 		return (QL_FUNCTION_FAILED);
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): Received LOGO from = %xh\n",
-	    ha->instance, tq->d_id.b24);
+	QL_PRINT_3(ha, "Received LOGO from = %xh\n", tq->d_id.b24);
 
 	EL(ha, "Emulate PLOGI from = %xh tq = %x\n", tq->d_id.b24, tq);
 
@@ -8812,20 +9222,14 @@
 
 	/* set payload. */
 	payload = (la_els_logi_t *)ubp->ub_buffer;
-	bzero(payload, sizeof (payload));
+	bzero(payload, sizeof (la_els_logi_t));
 
 	payload->ls_code.ls_code = LA_ELS_PLOGI;
 	payload->common_service.fcph_version = 0x2006;
-	payload->common_service.cmn_features = 0x8800;
-
-	CFG_IST(ha, CFG_CTRL_24258081) ?
-	    (payload->common_service.rx_bufsize = CHAR_TO_SHORT(
-	    ha->init_ctrl_blk.cb24.max_frame_length[0],
-	    ha->init_ctrl_blk.cb24.max_frame_length[1])) :
-	    (payload->common_service.rx_bufsize = CHAR_TO_SHORT(
-	    ha->init_ctrl_blk.cb.max_frame_length[0],
-	    ha->init_ctrl_blk.cb.max_frame_length[1]));
-
+	payload->common_service.cmn_features =
+	    ha->topology & QL_N_PORT ? 0x8000 : 0x8800;
+	payload->common_service.rx_bufsize =
+	    ha->loginparams.common_service.rx_bufsize;
 	payload->common_service.conc_sequences = 0xff;
 	payload->common_service.relative_offset = 0x03;
 	payload->common_service.e_d_tov = 0x7d0;
@@ -8848,8 +9252,6 @@
 	sp->flags |= SRB_UB_CALLBACK;
 	QL_UB_UNLOCK(ha);
 
-	ql_isp_els_handle_endian(ha, (uint8_t *)payload, LA_ELS_PLOGI);
-
 	if (done_q) {
 		ql_add_link_b(done_q, &sp->cmd);
 	} else {
@@ -8856,7 +9258,7 @@
 		ql_awaken_task_daemon(ha, sp, 0, 0);
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (QL_SUCCESS);
 }
@@ -8875,7 +9277,7 @@
 	ql_srb_t	*sp;
 	ql_head_t	done_q = { NULL, NULL };
 
-	QL_PRINT_10(CE_CONT, "(%d,%d): started\n", ha->instance, ha->vp_index);
+	QL_PRINT_10(ha, "started\n");
 
 	/*
 	 * First clear, internally queued commands
@@ -8889,10 +9291,6 @@
 			sp = link2->base_address;
 			link2 = link2->next;
 
-			if (sp->flags & SRB_ABORT) {
-				continue;
-			}
-
 			/* Remove srb from device command queue. */
 			ql_remove_link(&lq->cmd, &sp->cmd);
 			sp->flags &= ~SRB_IN_DEVICE_QUEUE;
@@ -8907,7 +9305,7 @@
 	DEVICE_QUEUE_UNLOCK(tq);
 
 	if (done_q.first != NULL) {
-		ql_done(done_q.first);
+		ql_done(done_q.first, B_FALSE);
 	}
 
 	if (drain && VALID_TARGET_ID(ha, tq->loop_id) && PD_PORT_LOGIN(tq)) {
@@ -8918,8 +9316,7 @@
 		EL(ha, "failed=%xh, d_id=%xh\n", rval, tq->d_id.b24);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_10(CE_CONT, "(%d,%d): done\n", ha->instance,
-		    ha->vp_index);
+		QL_PRINT_10(ha, "done\n");
 	}
 
 	return (rval);
@@ -8946,7 +9343,7 @@
 	fc_affected_id_t	*af;
 	port_id_t		d_id;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	/* Locate a buffer to use. */
 	ubp = ql_get_unsolicited_buffer(ha, FC_TYPE_EXTENDED_LS);
@@ -8995,7 +9392,7 @@
 		EL(ha, "Failed, get_unsolicited_buffer\n");
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 	}
 }
 
@@ -9017,7 +9414,7 @@
 	uint16_t	index;
 	ql_tgt_t	*tq;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	if (af->aff_format == FC_RSCN_PORT_ADDRESS) {
 		port_id_t d_id;
@@ -9030,10 +9427,10 @@
 			EL(ha, "SD_RSCN_RCVD %xh RPA\n", d_id.b24);
 			DEVICE_QUEUE_LOCK(tq);
 			tq->flags |= TQF_RSCN_RCVD;
+			ql_requeue_pending_cmds(ha, tq);
 			DEVICE_QUEUE_UNLOCK(tq);
 		}
-		QL_PRINT_3(CE_CONT, "(%d): FC_RSCN_PORT_ADDRESS done\n",
-		    ha->instance);
+		QL_PRINT_3(ha, "FC_RSCN_PORT_ADDRESS done\n");
 
 		return;
 	}
@@ -9050,6 +9447,7 @@
 					    tq->d_id.b24);
 					DEVICE_QUEUE_LOCK(tq);
 					tq->flags |= TQF_RSCN_RCVD;
+					ql_requeue_pending_cmds(ha, tq);
 					DEVICE_QUEUE_UNLOCK(tq);
 				}
 				break;
@@ -9060,6 +9458,7 @@
 					    tq->d_id.b24);
 					DEVICE_QUEUE_LOCK(tq);
 					tq->flags |= TQF_RSCN_RCVD;
+					ql_requeue_pending_cmds(ha, tq);
 					DEVICE_QUEUE_UNLOCK(tq);
 				}
 				break;
@@ -9070,6 +9469,7 @@
 					    tq->d_id.b24);
 					DEVICE_QUEUE_LOCK(tq);
 					tq->flags |= TQF_RSCN_RCVD;
+					ql_requeue_pending_cmds(ha, tq);
 					DEVICE_QUEUE_UNLOCK(tq);
 				}
 				break;
@@ -9079,10 +9479,60 @@
 			}
 		}
 	}
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
+ * ql_requeue_pending_cmds
+ *	Requeue target commands from pending queue to LUN queue
+ *
+ * Input:
+ *	ha:	adapter state pointer.
+ *	tq:	target queue pointer.
+ *	DEVICE_QUEUE_LOCK must be already obtained.
+ *
+ * Context:
+ *	Interrupt or Kernel context, no mailbox commands allowed.
+ */
+void
+ql_requeue_pending_cmds(ql_adapter_state_t *vha, ql_tgt_t *tq)
+{
+	ql_link_t		*link;
+	ql_srb_t		*sp;
+	ql_lun_t		*lq;
+	ql_adapter_state_t	*ha = vha->pha;
+
+	QL_PRINT_3(ha, "started\n");
+
+	REQUEST_RING_LOCK(ha);
+	for (link = ha->pending_cmds.first; link != NULL; link = link->next) {
+		sp = link->base_address;
+		if ((lq = sp->lun_queue) == NULL || lq->target_queue != tq) {
+			continue;
+		}
+		ql_remove_link(&ha->pending_cmds, &sp->cmd);
+
+		if (tq->outcnt) {
+			tq->outcnt--;
+		}
+		if (sp->flags & SRB_FCP_CMD_PKT) {
+			if (sp->fcp->fcp_cntl.cntl_qtype ==
+			    FCP_QTYPE_UNTAGGED) {
+				lq->flags &= ~LQF_UNTAGGED_PENDING;
+			}
+			if (lq->lun_outcnt != 0) {
+				lq->lun_outcnt--;
+			}
+		}
+		ql_add_link_t(&lq->cmd, &sp->cmd);
+		sp->flags |= SRB_IN_DEVICE_QUEUE;
+	}
+	REQUEST_RING_UNLOCK(ha);
+
+	QL_PRINT_3(ha, "done\n");
+}
+
+/*
  * ql_process_rscn
  *
  * Input:
@@ -9101,7 +9551,7 @@
 	uint16_t	index;
 	ql_tgt_t	*tq;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	if (af->aff_format == FC_RSCN_PORT_ADDRESS) {
 		port_id_t d_id;
@@ -9114,7 +9564,7 @@
 			sendup = ql_process_rscn_for_device(ha, tq);
 		}
 
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 
 		return (sendup);
 	}
@@ -9169,7 +9619,7 @@
 		}
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (sendup);
 }
